#ifndef KERNEL_UTIL_H
#define KERNEL_UTIL_H

/******************************************************
 * Some definitions which are used by the kernel only 
 ******************************************************/
#ifdef KERNEL

#if !defined __GNUC__ || __GNUC__ != 2
#include <ext/hash_map>
#else
#include <hash_map>
#endif

using namespace std;

#if !defined __GNUC__ || __GNUC__ != 2
using namespace __gnu_cxx;
#endif

// A hash function template used tp generate a hash number from
// pointer values.
template<class T>
class pointer_hash : public hash<unsigned int> {
public:
  size_t operator()(const T& x) const {
    return (*(hash<unsigned int> *)this)(((unsigned int)x)>>2);
  }
};

/******************************************************
 * End of internal kernel definitions    
 ******************************************************/
#endif



#endif
